#!/usr/bin/perl -w
use iowlcd;
package iowlcd;

# init iowlcd for first warrior
$num_warrior = iow_init();
print "found $num_warrior warriors\n";
$udh = iow_open(0);
iowlcd_setup($udh);

# use iowlcd
$status = iowlcd_read_status($udh);
print "status=$status\n";

# write some text
$txt = "hello";
$res = iowlcd_set_text($udh,0,0,$txt);

# read back some text
($res,$txt) = iowlcd_get_text($udh,0,0,5);
print "result=$txt\n";

# custom char demo
@mychar = (
 "00001110",
 "00010001",
 "00011011",
 "00010001",
 "00011111",
 "00010001",
 "00001110",
 "00000100"
);
$bits="";
foreach(@mychar) { $bits.=pack("B8",$_); }
iowlcd_load_chars($udh,7,1,$bits);
iowlcd_set_text($udh,3,3,"\x07<-new char!");
print "displaying custom char...\n";
sleep 5;

# clear display
iowlcd_display_clear($udh);

# draw vertical bars
$res = iowlcd_load_vbar_chars($udh);
$v_maxval = $IOWLCD_VBAR_UNITS * 4;
$txt = "vbar range: 0...$v_maxval";
iowlcd_set_text($udh,0,0,$txt);
print "$txt\n";
for(1..$v_maxval) {
  @vals = ( $_, $v_maxval-$_ );
  $res = iowlcd_draw_vbars($udh,15,0,4,\@vals);
  print "$_\n";
  iowlcd_set_text($udh,0,2,"value=$_");
  sleep 1;
}

# clear display
iowlcd_display_clear($udh);

# draw horizontal bar
$res = iowlcd_load_hbar_chars($udh);
$h_maxval = $IOWLCD_HBAR_UNITS * 8;
$txt = "hbar range: 0...$h_maxval";
iowlcd_set_text($udh,0,0,$txt);
print "$txt\n";
for(1..$h_maxval) {
  @vals = ( $_,$h_maxval-$_ );
  $res = iowlcd_draw_hbars($udh,0,1,8,\@vals);
  print "$_\n";
  iowlcd_set_text($udh,0,3,"value=$_");
  sleep 1;
}

# shut down iowlcd
iowlcd_shutdown($udh);
iow_close($udh);
iow_free();

print "ready\n";
